<script>
  import "../app.postcss";
  import { log_state, bearer_token } from "../plugins/store";
  import back from "../plugins/axios";
  import Fa from "svelte-fa";
  import {
    faHouse,
    faSignal,
    faPeopleGroup,
    faCopyright,
    faNewspaper,
    faHandHoldingHand,
  } from "@fortawesome/free-solid-svg-icons";

  let alert = "";

  function login() {
    const params = new URLSearchParams();
    params.append("grant_type", "password");
    params.append("username", $log_state.username);
    params.append("password", $log_state.password);
    back
      .post("/token", params)
      .then((res) => {
        if (res.response) {
          if (res.response.status == 401) {
            alert = "Nom d'utilisateur ou mot de passe incorrect";
          } else {
            alert = "Une erreur est survenue";
          }
        }
        bearer_token.set(res.data.access_token);
      })
      .catch((/** @type {any} */ err) => {
        console.log(err);
      });
  }
</script>

<input
  type="checkbox"
  checked={$bearer_token == ""}
  id="my-modal"
  class="modal-toggle"
/>
<div class="modal">
  <div class="modal-box">
    <h3 class="font-bold text-lg">Connexion à l'interface</h3>
    <form on:submit|preventDefault={login}>
      <div class="form-control">
        <label class="label" for="email">
          <span class="label-text">Nom d'utilisateur</span>
        </label>
        <input
          type="username"
          name="username"
          placeholder="Nom d'utilisateur"
          class="input input-bordered"
          bind:value={$log_state.username}
        />
      </div>
      <div class="form-control">
        <label class="label" for="password">
          <span class="label-text">Mot de passe</span>
        </label>
        <input
          type="password"
          name="password"
          placeholder="Mot de passe"
          class="input input-bordered"
          bind:value={$log_state.password}
        />
      </div>
      <div class="form-control mt-5">
        {#if alert}
          <div class="alert alert-error">
            {alert}
          </div>
        {/if}
      </div>
      <div class="modal-action">
        <button class="btn" on:click={login}>Se connecter</button>
      </div>
    </form>
  </div>
</div>

<div class="fixed top-0 navbar bg-base-200 z-10">
  <div class="flex-none">
    <label for="my-drawer" class="btn btn-ghost drawer-button">
      <svg
        xmlns="http://www.w3.org/2000/svg"
        fill="none"
        viewBox="0 0 24 24"
        class="inline-block w-5 h-5 stroke-current"
        ><path
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M4 6h16M4 12h16M4 18h16"
        /></svg
      >
    </label>
  </div>
  <div class="flex-1">
    <a href="/" class="btn btn-ghost normal-case text-xl"
      >Panel d'administration</a
    >
  </div>
  <div class="flex-none">
    <!-- <button class="btn btn-square btn-ghost">
        <svg
          xmlns="http://www.w3.org/2000/svg"
          fill="none"
          viewBox="0 0 24 24"
          class="inline-block w-5 h-5 stroke-current"
          ><path
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M5 12h.01M12 12h.01M19 12h.01M6 12a1 1 0 11-2 0 1 1 0 012 0zm7 0a1 1 0 11-2 0 1 1 0 012 0zm7 0a1 1 0 11-2 0 1 1 0 012 0z"
          /></svg
        >
      </button> -->
  </div>
</div>

<div class="drawer">
  <input id="my-drawer" type="checkbox" class="drawer-toggle" />
  <div class="drawer-content">
    <!-- center container -->
    <div class="container mx-auto mt-32">
      <slot />
    </div>
  </div>
  <div class="drawer-side">
    <label for="my-drawer" class="drawer-overlay" />
    <ul class="menu p-4 w-80 bg-base-100 text-base-content">
      <!-- Sidebar content here -->
      <li><a href="/"><Fa icon={faHouse} /> General</a></li>
      <li><a href="/streamers"><Fa icon={faSignal} /> Streamers</a></li>
      <li><a href="/teams"><Fa icon={faPeopleGroup} /> Equipe</a></li>
      <li><a href="/sponsors"><Fa icon={faCopyright} /> Sponsors</a></li>
      <li><a href="/articles"><Fa icon={faNewspaper} /> Articles</a></li>
      <li><a href="/associations"><Fa icon={faHandHoldingHand} /> Assos</a></li>
    </ul>
  </div>
</div>
